.586
.model flat, stdcall
option casemap :none
;************************************************************
;  24.10.2002
;  Innermost QuickSort loop
;  Sets pivot element to its correct position
;  Params   : pointer to array to be processed 
;             pointer to pivot element/record
;             length  row/record
;             count rows/records
;             position SortKey
;             length  SortKey
;  Returns  : Offset pivot element


;************************************************************
StrComp    PROTO :DWORD,:DWORD,:DWORD
SwapString PROTO :DWORD,:DWORD,:DWORD

.code

align 8

QSrtCore1 proc uses ebx ecx edx edi esi , 
           pArray:dword,
           pPivotSort:dword,        ; Pointer to Sortkey to be inserted
           RecLen:dword,            ; Length of Sortrecord 
           NumRec:dword,            ; Number of Sortrecords - 1
           SortPos:dword,           ; Position of Sortkey within Sortrecord
           SortLen:dword            ; Length of Sortkey

LOCAL   LowerIndex    :DWORD
LOCAL   UpperIndex    :DWORD
LOCAL   pCMP1         :DWORD
LOCAL   pCMP2         :DWORD
LOCAL   pSort1        :DWORD
LOCAL   pSort2        :DWORD

;###########################################################################
; 
;###########################################################################

                    
        mov ecx,    SortLen
        mov eax,    NumRec
        mov UpperIndex,      eax
        xor eax,    eax
        xor edx,    edx

        mov LowerIndex, 1

        mov edi,    pPivotSort
        mov esi,    pArray
        mov eax,    NumRec                ; Offset des oberen Vergleichssatzes
        mov pCMP1,  esi
        sub eax,    1                     ; Offset = (NumRec - 1) * RecLen
        mov pCMP2,  esi
        mul RecLen
        mov pSort2, esi
        add pCMP2,  eax
        mov pSort1, esi
        add pSort2, eax

        mov eax,    SortPos
        sub eax,    1                     ; SortOffset  
        add pSort1, eax                   ; Offset auf Sortierbegriff im 1.Satz(unten)
        add pSort2, eax                   ; Offset auf Sortierbegriff im 2.Satz(oben)

        mov ebx,    RecLen
align 8
        .repeat
           .repeat
;###########################################################################
; Comparing 2 Sortkeys
;###########################################################################
              invoke StrComp, pSort1, pPivotSort, SortLen
              .if eax == dword ptr[-1]
                 jmp @F
              .endif

              jmp NEXT1                   ; Pivot = Sort1           
@@:
              mov eax,        ebx         ; "timed"
              add LowerIndex, 1
              add pCMP1,      eax         ;   ebx=SortSatzlaenge
              add pSort1,     ebx
              mov eax,        LowerIndex
              
           .until eax > UpperIndex
NEXT1:
           mov eax, LowerIndex
           .if eax > UpperIndex
              ret
           .endif 

           .repeat
              invoke StrComp, pSort2, pPivotSort, SortLen
              .if eax == 1
                 jmp @F
              .endif
               jmp NEXT2               
@@:
              mov eax,          ebx
              sub UpperIndex,   1
              sub pCMP2,        eax
              sub pSort2,       ebx
              mov eax,          LowerIndex
              
           .until eax > UpperIndex
NEXT2:
           mov eax, LowerIndex
           .if eax <= UpperIndex  

;###########################################################################
; Swapping SortRecords 
;###########################################################################
                invoke SwapString , pCMP1, pCMP2, RecLen                      
                mov eax,            ebx              ; Recordlength
                add LowerIndex,     1                
                add pCMP1,          ebx              ; Offset lower Sortkey
                add pSort1,         eax              ; Offset lower Sortrecord 
                sub pCMP2,          ebx              ; Offset upper Sortkey
                sub pSort2,         eax              ; Offset lower Sortrecord
                sub UpperIndex,     1
  
           .endif
           mov eax, LowerIndex

        .until eax > UpperIndex

        mov eax, LowerIndex

        ret

QSrtCore1 endp



END

